> For the complete documentation index, see [llms.txt](https://docs.yemreak.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.yemreak.com/arsiv/yazilarim/thread-pool-executors-kavrami.md).

# Thread Pool (Executors) Kavramı

Java, Kotlin ThreadPoolExecuter, Executors kavramları ve birden fazla thread ile işlerin yönetimi multithreding

## 👀 Thread Pool Nasıl Çalışır

* 🚄 Yapılacak işler **Task Queue** içerisinde sıraya alınır
* 🦄 Her iş, **tek tek** oluşturulan **Thread Pool** üzerindeki boş bulunan *thread* üzerinde tamamlanır
* 💦 Tamamlanan işlerden sonra *thread* serbest bırakılır, **Task Queue** üzerinden yeni iş alınır

![](https://2136337814-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F3IVBqG9Jn8K2viWOpgUm%2Fuploads%2Fgit-blob-3a0022c41802b00bca5c38ddc6d39ac012698f65%2Fthread_pool.png?alt=media)

## ⭐ Thread Pool Türleri

| 💎 Tür              | 📝 Açıklama                                                                        | 🤔 Ne zaman tercih edilmeli                                                               |
| ------------------- | ---------------------------------------------------------------------------------- | ----------------------------------------------------------------------------------------- |
| ⚡ Fixed             | Sabit sayıda *thread* ile havuz oluşturulur, boşta *thread* yoksa işler bekletilir | Genellikle tercih edilen en iyi durumdur                                                  |
| 🤹‍♂️ Cached        | Lazım oldukça *thread* oluşturulur,                                                | Uzun süreli işlemlerde kullanılmaz, sistemin kaldıramayacağı kadar thread oluşturulabilir |
| 🕐 Scheduled        | Belirli aralıklarla işleri sırayla yapan *thread* yapısı                           | Periyodik olarak yapılacak işler                                                          |
| 🦄 Single           | Tüm işler için tek bir *thread* yapısı oluşturulur.                                | Tek bir iş için tercih edilir                                                             |
| 🧛‍♂️ Work Stealing | İş için gerekli sayıda thread oluşturur                                            | Çoklu işlem gücü olan makinelerde, *paralelizm* için kullanılır                           |

## 👨‍💼 Executor Yönetimi

| 💠 Metot                                      | 📝 Açıklama                                                                                                            |
| --------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------- |
| `shutdownNow()`                               | Executor'u direkt olarak sonlandırır, verilen görevleri çalıştırmaz, olan görevler tamamlanır ama metotlar tamamlanmaz |
| `isTerminated()`                              | Kapatma sinyali aldığında ve *executor* işini bitirdiği zaman `true` verir                                             |
| `isShutdown()`                                | Kapatma sinyali aldığında `true` verir                                                                                 |
| `awaitTermination(long timeout,TimeUnitunit)` | Thread'i executor görevini tamamlayıncaya kadar yada verilen süre kadar bloklar                                        |

## 🔗 Faydalı Kaynaklar

{% embed url="<https://howtodoinjava.com/java/multi-threading/java-thread-pool-executor-example/>" %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.yemreak.com/arsiv/yazilarim/thread-pool-executors-kavrami.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
